



















var nTestsRun = 0;
var nPassed = 0, nRTE = 0;	
var nFailed = 0;
function PassTest() { nTestsRun++; nPassed++; }
function FailTest(m) { OutputMessage("Line( " + 16 + " ) : " + m); nTestsRun++; nFailed++; }









function CheckExpr(e, l, s) {
	nTestsRun++;
	var failed = ( ! (e) );
	if( failed ) {
		nFailed++;
		OutputMessage(l + " : " + s);
		}
	else {
		nPassed++;
		}
	return( failed );
	}
function FinalResult() {
	OutputMessage("Total tests : " + nTestsRun);
	OutputMessage("Passed " + nPassed + " test" + ((nPassed != 1) ? 's' : ""));
	if(nRTE != 0) OutputMessage("Run Time Exceptions " + nRTE + " test" + ((nRTE != 1) ? 's' : ""));
	OutputMessage("Failed " + nFailed + " test" + ((nFailed != 1) ? 's' : ""));
	}




var hexDigits = "0123456789ABCDEF";

function thmToHex(i)
{
	var res = "";

	do {
		var fourBits = i & 0xf;
		i >>>= 4;
		c = hexDigits.charAt(fourBits);
		res = c + res;
		}
	while(i != 0);
	return(res);
}

function thmDecodeError(e)
{
	thmMessage(thmToHex(e.number >>> 16) 
				+ ":" 
				+ (e.number & 0xffff) 
				+ " : "
				+ e.name
				+ " : "
				+ e.description
				);
	CheckExpr(e.description == e.message, 74, "e.description == e.message");
}

function thmDecodeObject(o)
{
	typeof(o);
	thmMessage(o.toString());
	for(i in o) {
		thmMessage("-- " + i + " : " + o[i]);
		}
	thmMessage("");
}

function thmDecodeRE(re)
{
thmMessage("RE.input : " + re.input);
thmMessage("RE.index : " + re.index);
thmMessage("RE.lastIndex : " + re.lastIndex);
thmMessage("RE.lastMatch : " + re.lastMatch);
thmMessage("RE.lastParen : " + re.lastParen);
thmMessage("RE.leftContext : " + re.leftContext);
thmMessage("RE.rightContext : " + re.rightContext);
thmMessage("RE.$1 : " + re.$1);
thmMessage("RE.$2 : " + re.$2);
thmMessage("RE.$3 : " + re.$3);
thmMessage("RE.$4 : " + re.$4);
thmMessage("RE.$5 : " + re.$5);
thmMessage("RE.$6 : " + re.$6);
thmMessage("RE.$7 : " + re.$7);
thmMessage("RE.$8 : " + re.$8);
thmMessage("RE.$9 : " + re.$9);
}












function OutputMessage(m)
{

	println(m);



}








function thmMessage(m)
{
	OutputMessage(m);
}




function thmTrace(f, m)
{
	OutputMessage(thmGetFunctionName(f) + m);
}




function thmInFunction(f)
{
	thmTrace(f, " : entering");
}




function thmOutFunction(f)
{
	thmTrace(f, " : leaving");
}



function thmGetFunctionName(f)
{
	if(f == null) {
		return("Script Engine");
	}
	var re = new RegExp("^function ([A-Za-z0-9]+)","ig");
	var ar = re.exec(f);
	var fn = RegExp.$1;
	return(fn);
}
































var	completed =	false;
var	testcases;
var tc = 0;

SECTION	= "";
VERSION	= "";
BUGNUMBER =	"";




var	GLOBAL = "[object global]";
var PASSED = " PASSED!"
var FAILED = " FAILED! expected: ";

var	DEBUG =	false;









function TestCaseObject(l, n, d, e,	a )	{
	this.name		 = n;
	this.description = "Line( " + l + " ) : " + d;
	this.expect		 = e;
	this.actual		 = a;
	this.passed		 = true;
	this.reason		 = "";
	this.bugnumber	  =	BUGNUMBER;
	if(e === "error") {
		this.passed	= true;
		}
	else {
		this.passed	= getTestCaseResult( this.expect, this.actual );
		nTestsRun++;
		if( this.passed ) {
			nPassed++;
			}
		else {
			nFailed++;
			}
		}
}


























function startTest() {


























    testcases = new Array();
    tc = 0;
}





function AddTestCase( description, expect, actual ) {
    testcases[tc++] = new TestCaseObject(134, SECTION,description,expect,actual);
}

function test(toEval) {
    for ( tc=0; tc < testcases.length; tc++ ) {
		var oldResult = testcases[tc].passed;
		var reason = "";

        if(arguments.length != 0) { 
			try { testcases[tc].actual = eval( testcases[tc].actual ); }
			catch(e) { thmDecodeError(e); nRTE++; if(testcases[tc].expect === "error") testcases[tc].actual = "error"; }
			if(typeof(arguments[0]) == "string") {
				testcases[tc].reason += arguments[0];
				reason = arguments[0];
				}
			}
        testcases[tc].passed = writeTestCaseResult(
                            testcases[tc].expect,
                            testcases[tc].actual,
                            testcases[tc].description +" = "+ testcases[tc].actual + reason);
		if(oldResult != testcases[tc].passed) {
			if(oldResult) {
				nFailed++; nPassed--;
				}
			else {
				nFailed--; nPassed++;
				}
			}
    }
    stopTest();
    return ( testcases );
}





function getTestCaseResult(	expect,	actual ) {
	
	
		if ( actual	!= actual )	{
			if ( typeof	actual == "object" ) {
				actual = "NaN object";
			} else {
				actual = "NaN number";
			}
		}
		if ( expect	!= expect )	{
			if ( typeof	expect == "object" ) {
				expect = "NaN object";
			} else {
				expect = "NaN number";
			}
		}

		var	passed = ( expect == actual	) ?	true : false;

	
	
		if (	!passed
				&& typeof(actual) == "number"
				&& typeof(expect) == "number"
			) {
				if ( Math.abs(actual-expect) < 0.0000001 ) {
					passed = true;
				}
		}

	
		if ( typeof(expect)	!= typeof(actual) )	{
			passed = false;
		}

		return passed;
}








function writeTestCaseResult( expect, actual, string ) {
		var	passed = getTestCaseResult(	expect,	actual );
		writeFormattedResult( expect, actual, string, passed );
		return passed;
}
function writeFormattedResult( expect, actual, string, passed ) {
        var s = string ;
        s += ( passed ) ? PASSED : FAILED + expect;
        if( ! passed ) writeLineToLog( s);
        return passed;
}
function writeLineToLog( string	) {
	OutputMessage( string );
}
function writeHeaderToLog( string )	{
	OutputMessage( string );
}








function stopTest()	{
 	var gc;
	if ( gc != undefined ) {
		gc();
	}
}






function getFailedCases() {
  for (	var	i =	0; i < testcases.length; i++ ) {
	 if	( !	testcases[i].passed	) {
		OutputMessage( testcases[i].description	+" = " +testcases[i].actual	+" expected: "+	testcases[i].expect	);
	 }
  }
}
 



var	msPerDay =			86400000;
var	HoursPerDay	=		24;
var	MinutesPerHour =	60;
var	SecondsPerMinute =	60;
var	msPerSecond	=		1000;
var	msPerMinute	=		60000;		
var	msPerHour =			3600000;	
var             TZ_DIFF	= getTimeZoneDiff();  
var             TZ_PST = -8;  
var             PST_DIFF = TZ_DIFF - TZ_PST;  
var	TIME_1970	 = 0;
var	TIME_2000	 = 946684800000;
var	TIME_1900	 = -2208988800000;








function getTimeZoneDiff()
{
  return -((new Date(2000, 1, 1)).getTimezoneOffset())/60;
}






function adjustResultArray(ResultArray, msMode)
{
  
  if (!PST_DIFF) {return;} 

  











 
  if (msMode)
  {
    
    
    var t = ResultArray[TIME]  +  TZ_DIFF*msPerHour;

    
    ResultArray[HOURS] = HourFromTime(t); 
    ResultArray[DAY] = WeekDay(t);
    ResultArray[DATE] = DateFromTime(t);
    ResultArray[MONTH] = MonthFromTime(t);
    ResultArray[YEAR] = YearFromTime(t);  
  }
  else
  {
    
    
    var t = ResultArray[TIME]  -  PST_DIFF*msPerHour;

    
    ResultArray[TIME] = t;
    ResultArray[UTC_HOURS] = HourFromTime(t); 
    ResultArray[UTC_DAY] = WeekDay(t);
    ResultArray[UTC_DATE] = DateFromTime(t);
    ResultArray[UTC_MONTH] = MonthFromTime(t);
    ResultArray[UTC_YEAR] = YearFromTime(t);
  }
}


function Day( t	) {
	return ( Math.floor(t/msPerDay ) );
}
function DaysInYear( y ) {
	if ( y % 4 != 0	) {
		return 365;
	}
	if ( (y	% 4	== 0) && (y	% 100 != 0)	) {
		return 366;
	}
	if ( (y	% 100 == 0)	&&	(y % 400 !=	0) ) {
		return 365;
	}
	if ( (y	% 400 == 0)	){
		return 366;
	} else {
		return "ERROR: DaysInYear("	+ y	+ ") case not covered";
	}
}
function TimeInYear( y ) {
	return ( DaysInYear(y) * msPerDay );
}
function DayNumber(	t )	{
	return ( Math.floor( t / msPerDay )	);
}
function TimeWithinDay(	t )	{
	if ( t < 0 ) {
		return ( (t	% msPerDay)	+ msPerDay );
	} else {
		return ( t % msPerDay );
	}
}
function YearNumber( t ) {
}
function TimeFromYear( y ) {
	return ( msPerDay *	DayFromYear(y) );
}
function DayFromYear( y	) {
	return (	365*(y-1970) +
				Math.floor((y-1969)/4) -
				Math.floor((y-1901)/100) +
				Math.floor((y-1601)/400) );
}
function InLeapYear( t ) {
	if ( DaysInYear(YearFromTime(t)) ==	365	) {
		return 0;
	}
	if ( DaysInYear(YearFromTime(t)) ==	366	) {
		return 1;
	} else {
		return "ERROR:	DayFromYear("+y+") case	not	covered";
	}
}
function YearFromTime( t ) {
	t =	Number(	t );
	var	sign = ( t < 0 ) ? -1 :	1;
	var	year = ( sign <	0 )	? 1969 : 1970;
	for	(	var	timeToTimeZero = t;	;  ) {
	
		timeToTimeZero -= sign * TimeInYear(year)

	
		if ( sign <	0 )	{
			if ( sign *	timeToTimeZero <= 0	) {
				break;
			} else {
				year +=	sign;
			}
		} else {
			if ( sign *	timeToTimeZero < 0 ) {
				break;
			} else {
				year +=	sign;
			}
		}
	}
	return ( year );
}
function MonthFromTime(	t )	{
	
	var	day	= DayWithinYear( t );
	var	leap = InLeapYear(t);

	if ( (0	<= day)	&& (day	< 31) )	{
		return 0;
	}
	if ( (31 <=	day) &&	(day < (59+leap)) )	{
		return 1;
	}
	if ( ((59+leap)	<= day)	&& (day	< (90+leap)) ) {
		return 2;
	}
	if ( ((90+leap)	<= day)	&& (day	< (120+leap)) )	{
		return 3;
	}
	if ( ((120+leap) <=	day) &&	(day < (151+leap)) ) {
		return 4;
	}
	if ( ((151+leap) <=	day) &&	(day < (181+leap)) ) {
		return 5;
	}
	if ( ((181+leap) <=	day) &&	(day < (212+leap)) ) {
		return 6;
	}
	if ( ((212+leap) <=	day) &&	(day < (243+leap)) ) {
		return 7;
	}
	if ( ((243+leap) <=	day) &&	(day < (273+leap)) ) {
		return 8;
	}
	if ( ((273+leap) <=	day) &&	(day < (304+leap)) ) {
		return 9;
	}
	if ( ((304+leap) <=	day) &&	(day < (334+leap)) ) {
		return 10;
	}
	if ( ((334+leap) <=	day) &&	(day < (365+leap)) ) {
		return 11;
	} else {
		return "ERROR:	MonthFromTime("+t+") not known";
	}
}
function DayWithinYear(	t )	{
		return(	Day(t) - DayFromYear(YearFromTime(t)));
}
function DateFromTime( t ) {
	var	day	= DayWithinYear(t);
	var	month =	MonthFromTime(t);

	if ( month == 0	) {
		return ( day + 1 );
	}
	if ( month == 1	) {
		return ( day - 30 );
	}
	if ( month == 2	) {
		return ( day - 58 -	InLeapYear(t) );
	}
	if ( month == 3	) {
		return ( day - 89 -	InLeapYear(t));
	}
	if ( month == 4	) {
		return ( day - 119 - InLeapYear(t));
	}
	if ( month == 5	) {
		return ( day - 150-	InLeapYear(t));
	}
	if ( month == 6	) {
		return ( day - 180-	InLeapYear(t));
	}
	if ( month == 7	) {
		return ( day - 211-	InLeapYear(t));
	}
	if ( month == 8	) {
		return ( day - 242-	InLeapYear(t));
	}
	if ( month == 9	) {
		return ( day - 272-	InLeapYear(t));
	}
	if ( month == 10 ) {
		return ( day - 303-	InLeapYear(t));
	}
	if ( month == 11 ) {
		return ( day - 333-	InLeapYear(t));
	}

	return ("ERROR:	 DateFromTime("+t+") not known"	);
}
function WeekDay( t	) {
	var	weekday	= (Day(t)+4) % 7;
	return(	weekday	< 0	? 7	+ weekday :	weekday	);
}



function HourFromTime( t ) {
	var	h =	Math.floor(	t /	msPerHour )	% HoursPerDay;
	return ( (h<0) ? HoursPerDay + h : h  );
}
function MinFromTime( t	) {
	var	min	= Math.floor( t	/ msPerMinute )	% MinutesPerHour;
	return(	( min <	0 )	? MinutesPerHour + min : min  );
}
function SecFromTime( t	) {
	var	sec	= Math.floor( t	/ msPerSecond )	% SecondsPerMinute;
	return ( (sec <	0 )	? SecondsPerMinute + sec : sec );
}
function msFromTime( t ) {
	var	ms = t % msPerSecond;
	return ( (ms < 0 ) ? msPerSecond + ms :	ms );
}
function LocalTZA()	{
	return ( TZ_DIFF * msPerHour );
}
function UTC( t	) {
	return ( t - LocalTZA()	- DaylightSavingTA(t - LocalTZA()) );
}

function DaylightSavingTA( t ) {
	t =	t -	LocalTZA();

	var	dst_start =	GetFirstSundayInApril(t) + 2*msPerHour;
	var	dst_end	  =	GetLastSundayInOctober(t)+ 2*msPerHour;

	if ( t >= dst_start	&& t < dst_end ) {
		return msPerHour;
	} else {
		return 0;
	}

	
	

	OutputMessage( new Date( UTC(dst_start + LocalTZA())) );

	return UTC(dst_start  +	LocalTZA());
}
function GetFirstSundayInApril(	t )	{
	var	year = YearFromTime(t);
	var	leap = InLeapYear(t);

	var	april =	TimeFromYear(year) + TimeInMonth(0,	leap) +	TimeInMonth(1,leap)	+
	TimeInMonth(2,leap);

	for	( var first_sunday = april;	WeekDay(first_sunday) >	0;
		first_sunday +=	msPerDay )
	{
		;
	}

	return first_sunday;
}
function GetLastSundayInOctober( t ) {
	var	year = YearFromTime(t);
	var	leap = InLeapYear(t);

	for	( var oct =	TimeFromYear(year),	m =	0; m < 9; m++ )	{
		oct	+= TimeInMonth(m, leap);
	}
	for	( var last_sunday =	oct	+ 30*msPerDay; WeekDay(last_sunday)	> 0;
		last_sunday	-= msPerDay	)
	{
		;
	}
	return last_sunday;
}
function LocalTime(	t )	{
	return ( t + LocalTZA()	+ DaylightSavingTA(t) );
}
function MakeTime( hour, min, sec, ms )	{
	if ( isNaN(	hour ) || isNaN( min ) || isNaN( sec ) || isNaN( ms	) )	{
		return Number.NaN;
	}

	hour = ToInteger(hour);
	min	 = ToInteger( min);
	sec	 = ToInteger( sec);
	ms	 = ToInteger( ms );

	return(	(hour*msPerHour) + (min*msPerMinute) +
			(sec*msPerSecond) +	ms );
}
function MakeDay( year,	month, date	) {
	if ( isNaN(year) ||	isNaN(month) ||	isNaN(date)	) {
		return Number.NaN;
	}
	year = ToInteger(year);
	month =	ToInteger(month);
	date = ToInteger(date );

	var	sign = ( year <	1970 ) ? -1	: 1;
	var	t =	   ( year <	1970 ) ? 1 :  0;
	var	y =	   ( year <	1970 ) ? 1969 :	1970;

	var	result5	= year + Math.floor( month/12 );
	var	result6	= month	% 12;

	if ( year <	1970 ) {
	   for ( y = 1969; y >=	year; y	+= sign	) {
		 t += sign * TimeInYear(y);
	   }
	} else {
		for	( y	= 1970 ; y < year; y +=	sign ) {
			t += sign *	TimeInYear(y);
		}
	}

	var	leap = InLeapYear( t );

	for	( var m	= 0; m < month;	m++	) {
		t += TimeInMonth( m, leap );
	}

	if ( YearFromTime(t) !=	result5	) {
		return Number.NaN;
	}
	if ( MonthFromTime(t) != result6 ) {
		return Number.NaN;
	}
	if ( DateFromTime(t) !=	1 )	{
		return Number.NaN;
	}

	return ( (Day(t)) +	date - 1 );
}
function TimeInMonth( month, leap )	{
	
	
	

	if ( month == 3	|| month ==	5 || month == 8	|| month ==	10 ) {
		return ( 30*msPerDay );
	}

	
	if ( month == 0	|| month ==	2 || month == 4	|| month ==	6 ||
		 month == 7	|| month ==	9 || month == 11 ) {
		return ( 31*msPerDay );
	 }

	
	return ( (leap == 0) ? 28*msPerDay : 29*msPerDay );
}
function MakeDate( day,	time ) {
	if (	day	== Number.POSITIVE_INFINITY	||
			day	== Number.NEGATIVE_INFINITY	||
			day	== Number.NaN )	{
		return Number.NaN;
	}
	if (	time ==	Number.POSITIVE_INFINITY ||
			time ==	Number.POSITIVE_INFINITY ||
			day	== Number.NaN) {
		return Number.NaN;
	}
	return ( day * msPerDay	) +	time;
}
function TimeClip( t ) {
	if ( isNaN(	t )	) {
		return ( Number.NaN	);
	}
	if ( Math.abs( t ) > 8.64e15 ) {
		return ( Number.NaN	);
	}

	return ( ToInteger(	t )	);
}
function ToInteger(	t )	{
	t =	Number(	t );

	if ( isNaN(	t )	){
		return ( Number.NaN	);
	}
	if ( t == 0	|| t ==	-0 ||
		 t == Number.POSITIVE_INFINITY || t	== Number.NEGATIVE_INFINITY	) {
		 return	0;
	}

	var	sign = ( t < 0 ) ? -1 :	1;

	return ( sign *	Math.floor(	Math.abs( t	) )	);
}
function Enumerate ( o ) {
	var	p;
	for	( p	in o ) {
		OutputMessage( p +": " + o[p] );
	}
}



function GetContext() {
	return Packages.com.netscape.javascript.Context.getCurrentContext();
}
function OptLevel( i ) {
	i =	Number(i);
	var	cx = GetContext();
	cx.setOptimizationLevel(i);
}












































    var SECTION = "9.3.1-1";
    var VERSION = "ECMA_1";
    startTest();
    var TITLE   = "ToNumber applied to the String type";
    var BUGNUMBER="77391";

    writeHeaderToLog( SECTION + " "+ TITLE);

    var testcases = getTestCases();
    test();

function test() {
    for ( tc=0; tc < testcases.length; tc++ ) {
        testcases[tc].passed = writeTestCaseResult(
                            testcases[tc].expect,
                            testcases[tc].actual,
                            testcases[tc].description +" = "+
                            testcases[tc].actual );

        testcases[tc].reason += ( testcases[tc].passed ) ? "" : "wrong value ";
    }
    stopTest();
    return ( testcases );
}
function getTestCases() {
    var array = new Array();
    var item = 0;

    
    
    
    
    
    
    
    
    
    array[item++] = new TestCaseObject(80, SECTION,"Number('')",0,Number(""));
    array[item++] = new TestCaseObject(81, SECTION,"Number(' ')",0,Number(" "));
    array[item++] = new TestCaseObject(82, SECTION,"Number(\\t)",0,Number("\t"));
    array[item++] = new TestCaseObject(83, SECTION,"Number(\\n)",0,Number("\n"));
    array[item++] = new TestCaseObject(84, SECTION,"Number(\\r)",0,Number("\r"));
    array[item++] = new TestCaseObject(85, SECTION,"Number(\\f)",0,Number("\f"));

    array[item++] = new TestCaseObject(87, SECTION,"Number(String.fromCharCode(0x0009)",0,Number(String.fromCharCode(0x0009)));
    array[item++] = new TestCaseObject(88, SECTION,"Number(String.fromCharCode(0x0020)",0,Number(String.fromCharCode(0x0020)));
    array[item++] = new TestCaseObject(89, SECTION,"Number(String.fromCharCode(0x000C)",0,Number(String.fromCharCode(0x000C)));
    array[item++] = new TestCaseObject(90, SECTION,"Number(String.fromCharCode(0x000B)",0,Number(String.fromCharCode(0x000B)));
    array[item++] = new TestCaseObject(91, SECTION,"Number(String.fromCharCode(0x000D)",0,Number(String.fromCharCode(0x000D)));
    array[item++] = new TestCaseObject(92, SECTION,"Number(String.fromCharCode(0x000A)",0,Number(String.fromCharCode(0x000A)));

    
    

    array[item++] = new TestCaseObject(97, SECTION,"Number( '   ' +  999 )",999,Number( '   '+999));
    array[item++] = new TestCaseObject(98, SECTION,"Number( '\\n'  + 999 )",999,Number( '\n' +999));
    array[item++] = new TestCaseObject(99, SECTION,"Number( '\\r'  + 999 )",999,Number( '\r' +999));
    array[item++] = new TestCaseObject(100, SECTION,"Number( '\\t'  + 999 )",999,Number( '\t' +999));
    array[item++] = new TestCaseObject(101, SECTION,"Number( '\\f'  + 999 )",999,Number( '\f' +999));

    array[item++] = new TestCaseObject(103, SECTION,"Number( 999 + '   ' )",999,Number( 999+'   '));
    array[item++] = new TestCaseObject(104, SECTION,"Number( 999 + '\\n' )",999,Number( 999+'\n' ));
    array[item++] = new TestCaseObject(105, SECTION,"Number( 999 + '\\r' )",999,Number( 999+'\r' ));
    array[item++] = new TestCaseObject(106, SECTION,"Number( 999 + '\\t' )",999,Number( 999+'\t' ));
    array[item++] = new TestCaseObject(107, SECTION,"Number( 999 + '\\f' )",999,Number( 999+'\f' ));

    array[item++] = new TestCaseObject(109, SECTION,"Number( '\\n'  + 999 + '\\n' )",999,Number( '\n' +999+'\n' ));
    array[item++] = new TestCaseObject(110, SECTION,"Number( '\\r'  + 999 + '\\r' )",999,Number( '\r' +999+'\r' ));
    array[item++] = new TestCaseObject(111, SECTION,"Number( '\\t'  + 999 + '\\t' )",999,Number( '\t' +999+'\t' ));
    array[item++] = new TestCaseObject(112, SECTION,"Number( '\\f'  + 999 + '\\f' )",999,Number( '\f' +999+'\f' ));

    array[item++] = new TestCaseObject(114, SECTION,"Number( '   ' +  '999' )",999,Number( '   '+'999'));
    array[item++] = new TestCaseObject(115, SECTION,"Number( '\\n'  + '999' )",999,Number( '\n' +'999'));
    array[item++] = new TestCaseObject(116, SECTION,"Number( '\\r'  + '999' )",999,Number( '\r' +'999'));
    array[item++] = new TestCaseObject(117, SECTION,"Number( '\\t'  + '999' )",999,Number( '\t' +'999'));
    array[item++] = new TestCaseObject(118, SECTION,"Number( '\\f'  + '999' )",999,Number( '\f' +'999'));

    array[item++] = new TestCaseObject(120, SECTION,"Number( '999' + '   ' )",999,Number( '999'+'   '));
    array[item++] = new TestCaseObject(121, SECTION,"Number( '999' + '\\n' )",999,Number( '999'+'\n' ));
    array[item++] = new TestCaseObject(122, SECTION,"Number( '999' + '\\r' )",999,Number( '999'+'\r' ));
    array[item++] = new TestCaseObject(123, SECTION,"Number( '999' + '\\t' )",999,Number( '999'+'\t' ));
    array[item++] = new TestCaseObject(124, SECTION,"Number( '999' + '\\f' )",999,Number( '999'+'\f' ));

    array[item++] = new TestCaseObject(126, SECTION,"Number( '\\n'  + '999' + '\\n' )",999,Number( '\n' +'999'+'\n' ));
    array[item++] = new TestCaseObject(127, SECTION,"Number( '\\r'  + '999' + '\\r' )",999,Number( '\r' +'999'+'\r' ));
    array[item++] = new TestCaseObject(128, SECTION,"Number( '\\t'  + '999' + '\\t' )",999,Number( '\t' +'999'+'\t' ));
    array[item++] = new TestCaseObject(129, SECTION,"Number( '\\f'  + '999' + '\\f' )",999,Number( '\f' +'999'+'\f' ));

    array[item++] = new TestCaseObject(131, SECTION,"Number( String.fromCharCode(0x0009) +  '99' )",99,Number( String.fromCharCode(0x0009) + '99' ));
    array[item++] = new TestCaseObject(132, SECTION,"Number( String.fromCharCode(0x0020) +  '99' )",99,Number( String.fromCharCode(0x0020) + '99' ));
    array[item++] = new TestCaseObject(133, SECTION,"Number( String.fromCharCode(0x000C) +  '99' )",99,Number( String.fromCharCode(0x000C) + '99' ));
    array[item++] = new TestCaseObject(134, SECTION,"Number( String.fromCharCode(0x000B) +  '99' )",99,Number( String.fromCharCode(0x000B) + '99' ));
    array[item++] = new TestCaseObject(135, SECTION,"Number( String.fromCharCode(0x000D) +  '99' )",99,Number( String.fromCharCode(0x000D) + '99' ));
    array[item++] = new TestCaseObject(136, SECTION,"Number( String.fromCharCode(0x000A) +  '99' )",99,Number( String.fromCharCode(0x000A) + '99' ));

    array[item++] = new TestCaseObject(138, SECTION,"Number( String.fromCharCode(0x0009) +  '99' + String.fromCharCode(0x0009)",99,Number( String.fromCharCode(0x0009) + '99' + String.fromCharCode(0x0009)));
    array[item++] = new TestCaseObject(139, SECTION,"Number( String.fromCharCode(0x0020) +  '99' + String.fromCharCode(0x0020)",99,Number( String.fromCharCode(0x0009) + '99' + String.fromCharCode(0x0020)));
    array[item++] = new TestCaseObject(140, SECTION,"Number( String.fromCharCode(0x000C) +  '99' + String.fromCharCode(0x000C)",99,Number( String.fromCharCode(0x0009) + '99' + String.fromCharCode(0x000C)));
    array[item++] = new TestCaseObject(141, SECTION,"Number( String.fromCharCode(0x000D) +  '99' + String.fromCharCode(0x000D)",99,Number( String.fromCharCode(0x0009) + '99' + String.fromCharCode(0x000D)));
    array[item++] = new TestCaseObject(142, SECTION,"Number( String.fromCharCode(0x000B) +  '99' + String.fromCharCode(0x000B)",99,Number( String.fromCharCode(0x0009) + '99' + String.fromCharCode(0x000B)));
    array[item++] = new TestCaseObject(143, SECTION,"Number( String.fromCharCode(0x000A) +  '99' + String.fromCharCode(0x000A)",99,Number( String.fromCharCode(0x0009) + '99' + String.fromCharCode(0x000A)));

    array[item++] = new TestCaseObject(145, SECTION,"Number( '99' + String.fromCharCode(0x0009)",99,Number( '99' + String.fromCharCode(0x0009)));
    array[item++] = new TestCaseObject(146, SECTION,"Number( '99' + String.fromCharCode(0x0020)",99,Number( '99' + String.fromCharCode(0x0020)));
    array[item++] = new TestCaseObject(147, SECTION,"Number( '99' + String.fromCharCode(0x000C)",99,Number( '99' + String.fromCharCode(0x000C)));
    array[item++] = new TestCaseObject(148, SECTION,"Number( '99' + String.fromCharCode(0x000D)",99,Number( '99' + String.fromCharCode(0x000D)));
    array[item++] = new TestCaseObject(149, SECTION,"Number( '99' + String.fromCharCode(0x000B)",99,Number( '99' + String.fromCharCode(0x000B)));
    array[item++] = new TestCaseObject(150, SECTION,"Number( '99' + String.fromCharCode(0x000A)",99,Number( '99' + String.fromCharCode(0x000A)));

    array[item++] = new TestCaseObject(152, SECTION,"Number( String.fromCharCode(0x0009) +  99 )",99,Number( String.fromCharCode(0x0009) + 99 ));
    array[item++] = new TestCaseObject(153, SECTION,"Number( String.fromCharCode(0x0020) +  99 )",99,Number( String.fromCharCode(0x0020) + 99 ));
    array[item++] = new TestCaseObject(154, SECTION,"Number( String.fromCharCode(0x000C) +  99 )",99,Number( String.fromCharCode(0x000C) + 99 ));
    array[item++] = new TestCaseObject(155, SECTION,"Number( String.fromCharCode(0x000B) +  99 )",99,Number( String.fromCharCode(0x000B) + 99 ));
    array[item++] = new TestCaseObject(156, SECTION,"Number( String.fromCharCode(0x000D) +  99 )",99,Number( String.fromCharCode(0x000D) + 99 ));
    array[item++] = new TestCaseObject(157, SECTION,"Number( String.fromCharCode(0x000A) +  99 )",99,Number( String.fromCharCode(0x000A) + 99 ));

    array[item++] = new TestCaseObject(159, SECTION,"Number( String.fromCharCode(0x0009) +  99 + String.fromCharCode(0x0009)",99,Number( String.fromCharCode(0x0009) + 99 + String.fromCharCode(0x0009)));
    array[item++] = new TestCaseObject(160, SECTION,"Number( String.fromCharCode(0x0020) +  99 + String.fromCharCode(0x0020)",99,Number( String.fromCharCode(0x0009) + 99 + String.fromCharCode(0x0020)));
    array[item++] = new TestCaseObject(161, SECTION,"Number( String.fromCharCode(0x000C) +  99 + String.fromCharCode(0x000C)",99,Number( String.fromCharCode(0x0009) + 99 + String.fromCharCode(0x000C)));
    array[item++] = new TestCaseObject(162, SECTION,"Number( String.fromCharCode(0x000D) +  99 + String.fromCharCode(0x000D)",99,Number( String.fromCharCode(0x0009) + 99 + String.fromCharCode(0x000D)));
    array[item++] = new TestCaseObject(163, SECTION,"Number( String.fromCharCode(0x000B) +  99 + String.fromCharCode(0x000B)",99,Number( String.fromCharCode(0x0009) + 99 + String.fromCharCode(0x000B)));
    array[item++] = new TestCaseObject(164, SECTION,"Number( String.fromCharCode(0x000A) +  99 + String.fromCharCode(0x000A)",99,Number( String.fromCharCode(0x0009) + 99 + String.fromCharCode(0x000A)));

    array[item++] = new TestCaseObject(166, SECTION,"Number( 99 + String.fromCharCode(0x0009)",99,Number( 99 + String.fromCharCode(0x0009)));
    array[item++] = new TestCaseObject(167, SECTION,"Number( 99 + String.fromCharCode(0x0020)",99,Number( 99 + String.fromCharCode(0x0020)));
    array[item++] = new TestCaseObject(168, SECTION,"Number( 99 + String.fromCharCode(0x000C)",99,Number( 99 + String.fromCharCode(0x000C)));
    array[item++] = new TestCaseObject(169, SECTION,"Number( 99 + String.fromCharCode(0x000D)",99,Number( 99 + String.fromCharCode(0x000D)));
    array[item++] = new TestCaseObject(170, SECTION,"Number( 99 + String.fromCharCode(0x000B)",99,Number( 99 + String.fromCharCode(0x000B)));
    array[item++] = new TestCaseObject(171, SECTION,"Number( 99 + String.fromCharCode(0x000A)",99,Number( 99 + String.fromCharCode(0x000A)));


    

    array[item++] = new TestCaseObject(176, SECTION,"Number('Infinity')",Math.pow(10,10000),Number("Infinity"));
    array[item++] = new TestCaseObject(177, SECTION,"Number('-Infinity')",-Math.pow(10,10000),Number("-Infinity"));
    array[item++] = new TestCaseObject(178, SECTION,"Number('+Infinity')",Math.pow(10,10000),Number("+Infinity"));

    

    array[item++] = new TestCaseObject(182, SECTION,"Number('0')",0,Number("0"));
    array[item++] = new TestCaseObject(183, SECTION,"Number('-0')",-0,Number("-0"));
    array[item++] = new TestCaseObject(184, SECTION,"Number('+0')",0,Number("+0"));

    array[item++] = new TestCaseObject(186, SECTION,"Number('1')",1,Number("1"));
    array[item++] = new TestCaseObject(187, SECTION,"Number('-1')",-1,Number("-1"));
    array[item++] = new TestCaseObject(188, SECTION,"Number('+1')",1,Number("+1"));

    array[item++] = new TestCaseObject(190, SECTION,"Number('2')",2,Number("2"));
    array[item++] = new TestCaseObject(191, SECTION,"Number('-2')",-2,Number("-2"));
    array[item++] = new TestCaseObject(192, SECTION,"Number('+2')",2,Number("+2"));

    array[item++] = new TestCaseObject(194, SECTION,"Number('3')",3,Number("3"));
    array[item++] = new TestCaseObject(195, SECTION,"Number('-3')",-3,Number("-3"));
    array[item++] = new TestCaseObject(196, SECTION,"Number('+3')",3,Number("+3"));

    array[item++] = new TestCaseObject(198, SECTION,"Number('4')",4,Number("4"));
    array[item++] = new TestCaseObject(199, SECTION,"Number('-4')",-4,Number("-4"));
    array[item++] = new TestCaseObject(200, SECTION,"Number('+4')",4,Number("+4"));

    array[item++] = new TestCaseObject(202, SECTION,"Number('5')",5,Number("5"));
    array[item++] = new TestCaseObject(203, SECTION,"Number('-5')",-5,Number("-5"));
    array[item++] = new TestCaseObject(204, SECTION,"Number('+5')",5,Number("+5"));

    array[item++] = new TestCaseObject(206, SECTION,"Number('6')",6,Number("6"));
    array[item++] = new TestCaseObject(207, SECTION,"Number('-6')",-6,Number("-6"));
    array[item++] = new TestCaseObject(208, SECTION,"Number('+6')",6,Number("+6"));

    array[item++] = new TestCaseObject(210, SECTION,"Number('7')",7,Number("7"));
    array[item++] = new TestCaseObject(211, SECTION,"Number('-7')",-7,Number("-7"));
    array[item++] = new TestCaseObject(212, SECTION,"Number('+7')",7,Number("+7"));

    array[item++] = new TestCaseObject(214, SECTION,"Number('8')",8,Number("8"));
    array[item++] = new TestCaseObject(215, SECTION,"Number('-8')",-8,Number("-8"));
    array[item++] = new TestCaseObject(216, SECTION,"Number('+8')",8,Number("+8"));

    array[item++] = new TestCaseObject(218, SECTION,"Number('9')",9,Number("9"));
    array[item++] = new TestCaseObject(219, SECTION,"Number('-9')",-9,Number("-9"));
    array[item++] = new TestCaseObject(220, SECTION,"Number('+9')",9,Number("+9"));

    array[item++] = new TestCaseObject(222, SECTION,"Number('3.14159')",3.14159,Number("3.14159"));
    array[item++] = new TestCaseObject(223, SECTION,"Number('-3.14159')",-3.14159,Number("-3.14159"));
    array[item++] = new TestCaseObject(224, SECTION,"Number('+3.14159')",3.14159,Number("+3.14159"));

    array[item++] = new TestCaseObject(226, SECTION,"Number('3.')",3,Number("3."));
    array[item++] = new TestCaseObject(227, SECTION,"Number('-3.')",-3,Number("-3."));
    array[item++] = new TestCaseObject(228, SECTION,"Number('+3.')",3,Number("+3."));

    array[item++] = new TestCaseObject(230, SECTION,"Number('3.e1')",30,Number("3.e1"));
    array[item++] = new TestCaseObject(231, SECTION,"Number('-3.e1')",-30,Number("-3.e1"));
    array[item++] = new TestCaseObject(232, SECTION,"Number('+3.e1')",30,Number("+3.e1"));

    array[item++] = new TestCaseObject(234, SECTION,"Number('3.e+1')",30,Number("3.e+1"));
    array[item++] = new TestCaseObject(235, SECTION,"Number('-3.e+1')",-30,Number("-3.e+1"));
    array[item++] = new TestCaseObject(236, SECTION,"Number('+3.e+1')",30,Number("+3.e+1"));

    array[item++] = new TestCaseObject(238, SECTION,"Number('3.e-1')",.30,Number("3.e-1"));
    array[item++] = new TestCaseObject(239, SECTION,"Number('-3.e-1')",-.30,Number("-3.e-1"));
    array[item++] = new TestCaseObject(240, SECTION,"Number('+3.e-1')",.30,Number("+3.e-1"));

    

    array[item++] = new TestCaseObject(244, SECTION,"Number('.00001')",0.00001,Number(".00001"));
    array[item++] = new TestCaseObject(245, SECTION,"Number('+.00001')",0.00001,Number("+.00001"));
    array[item++] = new TestCaseObject(246, SECTION,"Number('-0.0001')",-0.00001,Number("-.00001"));

    array[item++] = new TestCaseObject(248, SECTION,"Number('.01e2')",1,Number(".01e2"));
    array[item++] = new TestCaseObject(249, SECTION,"Number('+.01e2')",1,Number("+.01e2"));
    array[item++] = new TestCaseObject(250, SECTION,"Number('-.01e2')",-1,Number("-.01e2"));

    array[item++] = new TestCaseObject(252, SECTION,"Number('.01e+2')",1,Number(".01e+2"));
    array[item++] = new TestCaseObject(253, SECTION,"Number('+.01e+2')",1,Number("+.01e+2"));
    array[item++] = new TestCaseObject(254, SECTION,"Number('-.01e+2')",-1,Number("-.01e+2"));

    array[item++] = new TestCaseObject(256, SECTION,"Number('.01e-2')",0.0001,Number(".01e-2"));
    array[item++] = new TestCaseObject(257, SECTION,"Number('+.01e-2')",0.0001,Number("+.01e-2"));
    array[item++] = new TestCaseObject(258, SECTION,"Number('-.01e-2')",-0.0001,Number("-.01e-2"));

    

    array[item++] = new TestCaseObject(262, SECTION,"Number('1234e5')",123400000,Number("1234e5"));
    array[item++] = new TestCaseObject(263, SECTION,"Number('+1234e5')",123400000,Number("+1234e5"));
    array[item++] = new TestCaseObject(264, SECTION,"Number('-1234e5')",-123400000,Number("-1234e5"));

    array[item++] = new TestCaseObject(266, SECTION,"Number('1234e+5')",123400000,Number("1234e+5"));
    array[item++] = new TestCaseObject(267, SECTION,"Number('+1234e+5')",123400000,Number("+1234e+5"));
    array[item++] = new TestCaseObject(268, SECTION,"Number('-1234e+5')",-123400000,Number("-1234e+5"));

    array[item++] = new TestCaseObject(270, SECTION,"Number('1234e-5')",0.01234,Number("1234e-5"));
    array[item++] = new TestCaseObject(271, SECTION,"Number('+1234e-5')",0.01234,Number("+1234e-5"));
    array[item++] = new TestCaseObject(272, SECTION,"Number('-1234e-5')",-0.01234,Number("-1234e-5"));

    

    array[item++] = new TestCaseObject(276, SECTION,"Number('0x0')",0,Number("0x0"));
    array[item++] = new TestCaseObject(277, SECTION,"Number('0x1')",1,Number("0x1"));
    array[item++] = new TestCaseObject(278, SECTION,"Number('0x2')",2,Number("0x2"));
    array[item++] = new TestCaseObject(279, SECTION,"Number('0x3')",3,Number("0x3"));
    array[item++] = new TestCaseObject(280, SECTION,"Number('0x4')",4,Number("0x4"));
    array[item++] = new TestCaseObject(281, SECTION,"Number('0x5')",5,Number("0x5"));
    array[item++] = new TestCaseObject(282, SECTION,"Number('0x6')",6,Number("0x6"));
    array[item++] = new TestCaseObject(283, SECTION,"Number('0x7')",7,Number("0x7"));
    array[item++] = new TestCaseObject(284, SECTION,"Number('0x8')",8,Number("0x8"));
    array[item++] = new TestCaseObject(285, SECTION,"Number('0x9')",9,Number("0x9"));
    array[item++] = new TestCaseObject(286, SECTION,"Number('0xa')",10,Number("0xa"));
    array[item++] = new TestCaseObject(287, SECTION,"Number('0xb')",11,Number("0xb"));
    array[item++] = new TestCaseObject(288, SECTION,"Number('0xc')",12,Number("0xc"));
    array[item++] = new TestCaseObject(289, SECTION,"Number('0xd')",13,Number("0xd"));
    array[item++] = new TestCaseObject(290, SECTION,"Number('0xe')",14,Number("0xe"));
    array[item++] = new TestCaseObject(291, SECTION,"Number('0xf')",15,Number("0xf"));
    array[item++] = new TestCaseObject(292, SECTION,"Number('0xA')",10,Number("0xA"));
    array[item++] = new TestCaseObject(293, SECTION,"Number('0xB')",11,Number("0xB"));
    array[item++] = new TestCaseObject(294, SECTION,"Number('0xC')",12,Number("0xC"));
    array[item++] = new TestCaseObject(295, SECTION,"Number('0xD')",13,Number("0xD"));
    array[item++] = new TestCaseObject(296, SECTION,"Number('0xE')",14,Number("0xE"));
    array[item++] = new TestCaseObject(297, SECTION,"Number('0xF')",15,Number("0xF"));

    array[item++] = new TestCaseObject(299, SECTION,"Number('0X0')",0,Number("0X0"));
    array[item++] = new TestCaseObject(300, SECTION,"Number('0X1')",1,Number("0X1"));
    array[item++] = new TestCaseObject(301, SECTION,"Number('0X2')",2,Number("0X2"));
    array[item++] = new TestCaseObject(302, SECTION,"Number('0X3')",3,Number("0X3"));
    array[item++] = new TestCaseObject(303, SECTION,"Number('0X4')",4,Number("0X4"));
    array[item++] = new TestCaseObject(304, SECTION,"Number('0X5')",5,Number("0X5"));
    array[item++] = new TestCaseObject(305, SECTION,"Number('0X6')",6,Number("0X6"));
    array[item++] = new TestCaseObject(306, SECTION,"Number('0X7')",7,Number("0X7"));
    array[item++] = new TestCaseObject(307, SECTION,"Number('0X8')",8,Number("0X8"));
    array[item++] = new TestCaseObject(308, SECTION,"Number('0X9')",9,Number("0X9"));
    array[item++] = new TestCaseObject(309, SECTION,"Number('0Xa')",10,Number("0Xa"));
    array[item++] = new TestCaseObject(310, SECTION,"Number('0Xb')",11,Number("0Xb"));
    array[item++] = new TestCaseObject(311, SECTION,"Number('0Xc')",12,Number("0Xc"));
    array[item++] = new TestCaseObject(312, SECTION,"Number('0Xd')",13,Number("0Xd"));
    array[item++] = new TestCaseObject(313, SECTION,"Number('0Xe')",14,Number("0Xe"));
    array[item++] = new TestCaseObject(314, SECTION,"Number('0Xf')",15,Number("0Xf"));
    array[item++] = new TestCaseObject(315, SECTION,"Number('0XA')",10,Number("0XA"));
    array[item++] = new TestCaseObject(316, SECTION,"Number('0XB')",11,Number("0XB"));
    array[item++] = new TestCaseObject(317, SECTION,"Number('0XC')",12,Number("0XC"));
    array[item++] = new TestCaseObject(318, SECTION,"Number('0XD')",13,Number("0XD"));
    array[item++] = new TestCaseObject(319, SECTION,"Number('0XE')",14,Number("0XE"));
    array[item++] = new TestCaseObject(320, SECTION,"Number('0XF')",15,Number("0XF"));

    return ( array );
}

FinalResult();







